// constants
const prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("rsseditor.");


// Function for numeric order for sorting arrays
// Compare by string if any of the arguments are not numbers (i.e. a - b is Nan)
function numericCompare(a, b)
{
	var r, as, bs;
	return !isNaN(r = a - b) ? r : (as = a.toString()) > (bs = b.toString()) ? 1 : as < bs ? -1 : 0;
}


function genGUID()
{
	// crude function, not actually random
	var hex = new Function("return Number(Math.floor(Math.random()*65536)).toString(16)");
	return "{" + hex() + hex() + "-" + hex() + "-" + hex() + "-" + hex() + "-" + hex() + hex() + hex() + "}";
}


function time(s)
{
	if (s == "") return "";
	const months = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
	var d = s ? new Date(s) : new Date();
	return isNaN(d.getFullYear()) || boolPref("UTCTime") ? d.toUTCString() : d.getFullYear() + "/" + months[d.getMonth()] + "/" + d.getDate() + " " + (d.getHours() < 10 ? "0" : "") + d.getHours() + ":" + (d.getMinutes() < 10 ? "0" : "") + d.getMinutes() + ":" + (d.getSeconds() < 10 ? "0" : "") + d.getSeconds();
}


// getBoolPref w/ exception handling (return false on failure)
function boolPref(pref)
{
	try
	{
		return prefs.getBoolPref(pref);
	}
	catch (e)
	{
		return false;
	}
}


function valueOf(id)
{
	try
	{
		return document.getElementById(id).value;
	}
	catch (e)
	{
		return null;
	}
}


function setValue(id, value)
{
	try
	{
		document.getElementById(id).value = value;
		return true;
	}
	catch (e)
	{
		return false;
	}
}


function insertElement(obj, name, contents)
{
	var d = obj.ownerDocument;
	obj.appendChild(d.createElement(name)).appendChild(d.createTextNode(contents));
}
